// October 24, 2002
// Homework problems for 1671
// A.  First complete the following program so that it gets a string
//     from the user, asks if they want to encrypt or decrypt,
//     then outputs the encrypted or decrypted result in capital letters.
// B.  Modify the program so that it also asks if they want to decrypt,
//     encrypt, or cryptanalyze.  If they want to cryptanalyze, then don't
//     ask for the key, instead decrypt the word using all possible keys,
//     outputting the results for the user to examine.

#include <iostream>
#include <cctype>
#include <string>
using namespace std;

// put the prototype for the function here:
string shift_cipher(string text, int key);

int main()
{
    string text;  // text they want to encrypt/decrypt
    char command; // one-letter command, d or e (for decrypt or encrypt)
    int key;      // key to use for the shifting encryption/decryption
    int i;

    cout << "Please input the word: ";
    cin >> text;
    cout << "Do you want to encrypt, decrypt or analyze (e/d/a)? ";
    cin >> command;
    if (tolower(command) == 'e') {
        cout << "Please type the key (choose from 0-25): ";
        cin >> key;
	cout << shift_cipher(text, key) << endl;
    } else if (tolower(command) == 'd') {
        cout << "Please type the key (choose from 0-25): ";
        cin >> key;
	cout << shift_cipher(text, -key) << endl;
    } else if (tolower(command) == 'a') {
	for (i = 0; i < 25; i++)
		cout << shift_cipher(text, i) << endl;
    } else
        cout << "Unknown command, program will exit" << endl;
    return 0;
}

// Here's the function that takes a word (text) and shifts the letters by
// the number key.  For example, if key is 2, then a B will become a D,
// a F will become an H, a Z will become a B.  If you want to use
// this function to decipher, then use a negative value for the key
string shift_cipher(string text, int key)
{
    int i;             // used to count through each letter in the text
    string new_text;   // this is the altered text, the answer
    char next_letter;  // used to do my calculation of each letter

    // first make all keys positive (for example, a -4 is the same as +22)
    // Also make key lie between 0 and 25 (for example, 29 is the same as 3)
    while (key < 0)  
        key += 26;
    key %= 26;

    // make a copy of the text
    new_text = text;

    // Go through the letters of the text one by one and transform them
    for (i=0; i < text.length(); i++)
    {
        next_letter = new_text[i];   // here's the letter we're working on
        if (isalpha(next_letter)) {  // we leave all symbols as they are
                                     // That is, only transform letters
            // translate to upper case, then turn the letter into a number
            // from 0 to 25 (A=0, B=1, etc)
            next_letter = toupper(next_letter) - 'A';

            // shift the number an amount determined by the key
            next_letter += key;      // Translate the letter by the key
            next_letter %= 26;

            // Turn the number back into an upper case letter
            next_letter += 'A'; 
            // Store the transformed letter in the text string
            new_text[i] = next_letter;
        }
    }
    // Hand back the answer
    return new_text;
}
